__noinference__{
#ifndef _FENV_H_
#define _FENV_H_
#ifndef _fenv_t_def_
#define _fenv_t_def_
typedef struct _fenv_t{
  struct _fpu_env_info{
    unsigned int _fpu_cw;
    unsigned int _fpu_sw;
    unsigned int _fpu_tagw;
    unsigned int _fpu_ipoff;
    unsigned int _fpu_ipsel;
    unsigned int _fpu_opoff;
    unsigned int _fpu_opsel;
  } _fpu;
  unsigned int _sse_mxcsr;
} fenv_t;
#endif
#ifndef _fexcept_t_def_
#define _fexcept_t_def_
typedef struct _fexcept_t{
  unsigned short _fpu_exceptions;
  unsigned short _sse_exceptions;
} fexcept_t;
#endif
#ifndef __fe_dfl_env_def_
#define __fe_dfl_env_def_
extern const fenv_t * _fe_dfl_env;
#endif
#ifndef FE_INVALID
#define FE_INVALID (1 << 0)
#endif
#ifndef FE_OVERFLOW
#define FE_OVERFLOW (1 << 3)
#endif
#ifndef FE_DIVBYZERO
#define FE_DIVBYZERO (1 << 2)
#endif
#ifndef FE_TONEAREST
#define FE_TONEAREST (0)
#endif
#ifndef FE_DENORMAL
#define FE_DENORMAL (1 << 1)
#endif
#ifndef FE_UPWARD
#define FE_UPWARD (2)
#endif
#ifndef FE_DFL_ENV
#define FE_DFL_ENV (_fe_dfl_env)
#endif
#ifndef FE_TOWARDZERO
#define FE_TOWARDZERO (3)
#endif
#ifndef FE_INEXACT
#define FE_INEXACT (1 << 5)
#endif
#ifndef FE_ALL_EXCEPT
#define FE_ALL_EXCEPT (FE_DIVBYZERO | FE_INEXACT | FE_INVALID | FE_OVERFLOW | FE_UNDERFLOW | FE_DENORMAL)
#endif
#ifndef FE_UNDERFLOW
#define FE_UNDERFLOW (1 << 4)
#endif
#ifndef FE_DOWNWARD
#define FE_DOWNWARD (1)
#endif

  extern "C" int feclearexcept(int);

  extern "C" int fegetexceptflag(fexcept_t @, int);

  extern "C" int feraiseexcept(int);

  extern "C" int fesetexceptflag(const fexcept_t @, int);

  extern "C" int fetestexcept(int);

  extern "C" int fegetround(void);

  extern "C" int fesetround(int);

  extern "C" int fegetenv(fenv_t @);

  extern "C" int feholdexcept(fenv_t @);

  extern "C" int fesetenv(const fenv_t @);

  extern "C" int feupdateenv(const fenv_t @);
#endif
}
